/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//************************************************************//
//                                                            //
//          :   K . H                                     //
//                                                            //
//         Ŭ Thing Top                       //
//                                                            //
//************************************************************//

#include "mptr.h"

#ifndef _K_H
#define _K_H
#include <String.h>

//  Ϸ  ι
const unsigned int WRDSIZE = sizeof(void*);

inline size_t
Round(size_t s) {
    return (size_t)((s + WRDSIZE - 1)/WRDSIZE)*WRDSIZE;
}

//  ϴ   Ÿ
typedef char *Char_p;

//  Ÿ, ܼ ShapeRep Ļ Ŭ  ̿
// ϴ ȣ ̱  Ѵ.
enum Exemplar { };

//  Ϸ  ι

class Top {
public:
    //  Ŭ ڷᰡ ,  Ϸ ϴ
    // __vtbl  ִ.  Ŭ Ļ  Ŭ
    // __vtbl  ü ׻ ù°  Ѵ.
    //  ̷  ϴ Ϸ   ƴ
    // , __vtbl ã  ٸ  ʿϸ,
    // ⿡ Ұ  ٲ  ʿ䰡 ִ
    // ( , findVtblEntry  Լ).
    // ⿡  ý   
    // __vtbl  Ѵ.

    virtual ~Top() { }
    mptr* findVtblEntry(vptp);
    void update(String, String, const char *const = "");
    static void operator delete(void *p) {
        ::operator delete(p);
    }
    // doit ڰ  ϴµ  ִ  Լ̴.
    virtual Top *doit();
protected:
    Top()  { }
    static void *operator new(size_t l) {
        return ::operator new(l);
    }
private:
    //  Ǵϱ   Լ ͸ Ѵ.
    int compareFuncs(int, vptp, vptp);
};

typedef Top *Topp;

class Thing: public Top {
    //  "rep" ʵ Thing ĻѴ. ̴
    //   Ŭ    Ѵ.
public:
    virtual Thing *type() { return this; }
    Thing() { }
    virtual Thing *cutover();       // ʵ  Լ
    virtual ~Thing() { }            // Ҹ
    int docutover();
};

typedef Thing *Thingp;
#endif
