/* Advanced C++ Programming Styles and Idioms */

class Complex {
public:
friend Complex & operator+(double, const Complex&);
       Complex & operator+(const Complex&) const;
friend Complex & operator-(double, const Complex&);
       Complex & operator-(const Complex&) const;
friend Complex & operator*(double, const Complex&);
       Complex & operator*(const Complex&) const;
friend Complex & operator/(double, const Complex&);
       Complex & operator/(const Complex&) const;
       double rpart() const;
       double ipart() const;
       Complex(double=0.0, double=0.0);
private:
       double realPart, imaginaryPart;
};
