/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

// ANSI C++ bool Ÿ  Ѵ.  
//enum Bool {true, false} ;
#define Bool bool

class DigitString {
public:
    // ...
};

class LineNumber {
public:
    // ...
};

class Frame {
public:
    // ...
};

class Rack {
public:
    // ...
};

class Pair {
public:
    // ...
};

class Channel {
public:
    // ...
};

class Telephone {
public:
    enum PhoneType { POTS, ISDN, OPERATOR, OTHER } phoneType()
        { return phoneTypeVal; }
    void ring();
    Bool isOnHook();
    Bool isTalking();
    Bool isDialing();
    DigitString collectDigits();
    LineNumber extension();  // Ʒ  ʴ´.
    ~Telephone();
protected:
    LineNumber extensionData;
    PhoneType phoneTypeVal;
    Telephone() { };
};

class POTSPhone: public Telephone {
public:
    Bool runDiagnostics();
    POTSPhone() {
//  ڿ phoneTypeVal  Ŭ  ʱȭ  ߴµ,
// Ʈ콺Ʈ "The C++ Programming Language 2nd Ed." 580  4.12.6.2 
// ӹ   Ŭ  ʱȭ    ִ.
        phoneTypeVal = POTS;
        // . . . .
    }
    POTSPhone(POTSPhone &p) {
        phoneTypeVal = POTS;
        // . . . .
    }
    ~POTSPhone();
private:
    Frame frameNumberVal;
    Rack rackNumberVal;
    Pair pairVal;
};

class ISDNPhone: public Telephone {
public:
    ISDNPhone() {
        phoneTypeVal = ISDN;
        // . . . .
    }
    ISDNPhone(ISDNPhone &p) {
        phoneTypeVal = ISDN;
        // . . . .
    }
    ~ISDNPhone();
    void sendBPacket();  // B äη Ŷ 
    void sendDPacket();  // D äη Ŷ 
private:
    Channel b1, b2, d;
};
