/* Advanced C++ Programming Styles and Idioms */

#include <iostream.h>

class Base {
public:
    virtual void pure() = 0;
};

class Derived: public Base {
public:
    void pure() { cout << "Derived::pure" << endl; }
    void foo() { Base::pure(); };
};

void Base::pure() { cout << "Base::pure" << endl; }

int main()
{
    Derived d;
    d.Base::pure();
    d.foo();
    d.pure();
    Base *b = &d;
    b->pure();
    return 0;
}
