/* Advanced C++ Programming Styles and Idioms */

//   Complex Ŭ Ϻ ڵ ߰
class Complex {
friend class Imaginary;
public:
    Complex(double r = 0, double i = 0): rpart(r), ipart(i) { }
private:
    double rpart, ipart;
};

class Imaginary {  // Complex ӹ ʾ
public:
    Imaginary(double i = 0): ipart(i) { }
    Imaginary(const Complex &c): ipart(c.ipart) { }
    Imaginary& operator=(const Complex &c) {
        ipart = c.ipart; return *this;
    }
    Imaginary operator+(const Imaginary &c) const {
        return Imaginary(ipart + c.ipart);
    }
    Imaginary operator-(const Imaginary &c) const {
        return Imaginary(ipart - c.ipart);
    }
    Imaginary operator*(const Imaginary &c) {  }
    Imaginary operator/(const Imaginary &c) {  }
    operator double() { return ipart; }
    operator Complex() { return Complex(0, ipart); }
    Imaginary operator-() const { return Imaginary(-ipart); }
    // ....
private:
    double ipart;
};
