/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 3-5 */

#include <iostream.h>

class X {
public:
    X() {
        cout << "Default constructor is invoked." << endl;
    }
    X(const X&) {
        cout << "Copy constructor is invoked. " << endl;
    }
    ~X() {
        cout << "Destructor is invoked." << endl;
    }
};

void callByValue(X x) {
    cout << "Function callByValue() is invoked." << endl;
}

void callByReference(X& x) {
    cout << "Function callByReference() is invoked." << endl;
}

int main() {

    cout << "Declaring x1. " << endl;
    X x1;

    cout << endl << "Before calling callByValue(). "<< endl;
    callByValue(x1);
    cout << "After calling callByValue(). " << endl;
    
    cout << endl << "Before calling callByReference(). "<< endl;
    callByReference(x1);
    cout << "After calling callByReference(). " << endl << endl;

    return 0;
}
