/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 5-2 */

#include <iostream.h>

template <class T> 
void InsertionSort(T a[], int n) {
    int i, j;
    for (i = 1; i < n; i++) {
        if (a[i] < a[i-1]) {
            T temp = a[i];
            for (j = i - 1; j >= 0; --j) {
                a[j+1] = a[j];
                if (j == 0) break;
                if (a[j-1] < temp) break;
            }
            a[j] = temp;
        }
    }
}

template <class T>
void print(T a[], int n) {
    for (int i = 0; i < n; i++) cout << a[i] << " ";
}

int main() {
    int a[5] = { 3, 2, 4, 1, 5 };
    cout << "original integer array: "; 
    print(a, 5);
    cout << endl;

    InsertionSort(a, 5);
    cout << "sorted integer array: " ;
    print(a, 5);
    cout << endl;

    return 0;
}
