/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

/*-----------------------------------------------------------*/
/*                                                           */
/* File bmain.cc --     α׷           */
/*                                                           */
/*-----------------------------------------------------------*/

#include "bshapes.h"
extern "C" {
#include "Mgraphics.h"
}

/*
 * ȭũ XSIZE YSIZE  
 */
const int XSIZE = 640;
const int YSIZE = 480;

void
rotateList(Shape *s, Angle a)
{
    for (Shape *f = s;  f;  f = f->next())
    	f->rotate(a);
}

int
main(int argc, char **argv)
{
    Coordinate origin (0,0);
    MScreen *S1;
 
    /*
     * ׷  ʱȭ: ȣ ߰
     */

    MinitGraph(argc, argv);
    S1 = CreateScreen(XSIZE + 1, YSIZE + 1);
    SetScreen(S1);
    showGraph();
    setcolor(WHITE);
    clearScreen();

    /*
     * windowBorder ȭ   Ӹ ƴ϶
     *    ʱ  ۿ Ѵ.
     */

    Rect windowBorder(origin, XSIZE, YSIZE);

    // ﰢ ϳ 
    Shape * t = new Triangle(
    	Coordinate(100, 100),
    	Coordinate(200, 200),
    	Coordinate(300, 100)
    );
    windowBorder.append(t);
    //  ٸ.
    Ggetch();
    // (200, 200)̶ ο ߽ ǥ  windowBorder δ.
    windowBorder.move(Coordinate(200, 200));
    //  ٸ.
    Ggetch();

    // Circle Ŭ   ʾҴ.
    //    Shape * c = new Circle(Coordinate(500,652), 150);
    //    t->insert(c);

    //  ߽    ȸ
    rotateList(&windowBorder, Angle(M_PI/4.0));

    while (true) // loop forever!
        ;

    return 0;
}
