/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//************************************************************//
//                                                            //
//         :    T R I A N G L E . H                       //
//                                                            //
//         Ŭ Triangle  ̽                  //
//                                                            //
//************************************************************//

//     ﰢ  ǹ̷  ڵ ̴̽.

#define _TRIANGLE_H
#ifndef _TRIANGLE_H
#include "shaperep.h"
#include "coordinate.h"

class Triangle: public ShapeRep {
public:
    // exemplar 
    Shape make();
    Shape make(Coordinate, Coordinate, Coordinate);

    // ޸ 
    void *operator new(size_t);
    void operator delete(void *);
    void gc(size_t = 0);

    //   ǹ̷
    void draw();
    void rotate(double);
    void move(Coordinate);

    // Ŭ ƾ
    Triangle(Exemplar);
    Triangle();
    static void init();
private:
    // Ʒ Լ  ȣǾ ȵȴ.
    Shape make(Coordinate);
    Shape make(Coordinate, Coordinate);
private:
    // νϽ  
    Coordinate p1, p2, p3;
private:
    // ޸  ڷ
    static char *heap;
    static size_t poolInitialized;
    enum { PoolSize = 10 };
};

// Triangle exemplar  
extern ShapeRep *triangle;
#endif
