#include "polygon.hpp"
#include <cmath>

#if defined(_WINDOWS) || defined(_WIN32)
#  define EXPORT __declspec(dllexport)
#else
#  define EXPORT
#endif

class triangle : public polygon {
public:
    virtual double area() const {
        return side_length_ * side_length_ * sqrt(3) / 2;
    }
};


// the class factories
extern "C" EXPORT polygon* create() {
    return new triangle;
}

extern "C" EXPORT void destroy(polygon* p) {
    delete p;
}
