/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

const int STACK_SIZE = 10;

class Stack {
public:
    Stack();
    Stack(int);
    ~Stack();
    long top() const;
    long pop();
    void push(long);
private:
    long *items;
    int sp;
};

//   ׸ 2-3  κ

Stack::Stack() {
    items = new long[STACK_SIZE];
    sp = -1;
}

Stack::Stack(int size) {
    items = new long[size]; // Ÿ ִ sbrk(ý ȣ)̳ malloc(libc Լ) ϴ.
                            //  쿡 ڸ ȣѴٴ Ǹ ϰ.
    sp = -1;
}

Stack::~Stack() {
    delete[] items;         // free(libc Լ) ϴ. Ҹڸ ȣѴٴ Ǹ ϰ.
}

long Stack::top() const {
    return items[sp];
}

long Stack::pop() {
    return items[sp--];
}

void Stack::push(long i) {
    items[++sp] = i;
}

int main()
{
    Stack q;        //  Stack::Stack() ȣѴ.
    Stack r(15);    //  ٸ  Stack::Stack(int) ȣѴ.
    q.push(1);
    long i = q.top();
    q.pop();
}

//   ׸ 2-4  κ
