/* Advanced C++ Programming Styles and Idioms */

#include <malloc.h>
#include "3-16.cc"

extern void StringOutOfMemory();

String* String::newlist = 0;
static unsigned char memPool[String::POOLSIZE * sizeof(String)];
static const unsigned char *memPoolEnd =
    memPool + String::POOLSIZE + sizeof(String);

void String::operator delete(void *p) {
    String *s = (String *) p;
    s->freepointer = newlist;
    newlist = s;
}

void* String::operator new(size_t size) {
    if (size != sizeof(String)) {
        return ::malloc(size);
    } else if (newlist == (String*) memPoolEnd) {
        StringOutOfMemory();
        // new ο  ߻  return 0  ͸
        // ȯϴ  ó ϱ ٶ.
        throw;
        // return 0;
    } else if (!newlist) {
        newlist = (String*) memPool;
        // ANSI C++ for loop ο    ̸ ܺο
        //   .
        int i;
        for (i = 0; i < POOLSIZE - 1; i++) {
            newlist[i].freepointer = &(newlist[i+1]);
        }
        newlist[i].freepointer = (String*) memPoolEnd;
    }
    String *savenew = newlist;
    newlist = newlist->freepointer;
    return savenew;
}
