/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

#include <iostream.h>
#include <stddef.h>
// placement new ϱ   Ŭؾ Ѵ.
#include <new>

// gcc 2.9x ⺻ placement new   ϰ ִ.
// inline void *operator new(size_t, void *place) throw() { return place; }
//   ϴ new Լ θ ּóؾ߸ Ѵ.
// void *operator new(size_t, void *p) { return p; }

struct S {
    S();
    ~S();
};

char buf [sizeof(S)][100];
int bufIndex = 0;

void f() {
    S a;    // ڵ Ҵ/ʱȭ

    S *p = new S;          //  Ҵ
                           //  new   ã
                           // ڵ ʱȭ
    delete p;              //  
                           // ڵ 

    S *ppp = new (buf) S;  // buf   Ҵ
                           // ڵ ʱȭ
    ppp->S::~S();          //  
    // f()  
    // "a" ڵ Ǹ, ڽ ϴ ޸𸮸 ȯѴ.
}

//  Ȯ   ڵ
S::S() { cout << "S()" << endl; }
S::~S() { cout << "~S()" << endl; }

int main()
{
    f();
}
